/*
void Main() {
    print("Hello there!");
}

const string WindowTitle = "Campaign Points Calculator";
string resultText = "Result: ";
array<int> inputRanks(25, 1);
array<string> mapTexts = {
    "Map 1 Rank", "Map 2 Rank", "Map 3 Rank", "Map 4 Rank", "Map 5 Rank", 
    "Map 6 Rank", "Map 7 Rank", "Map 8 Rank", "Map 9 Rank", "Map 10 Rank", 
    "Map 11 Rank", "Map 12 Rank", "Map 13 Rank", "Map 14 Rank", "Map 15 Rank", 
    "Map 16 Rank", "Map 17 Rank", "Map 18 Rank", "Map 19 Rank", "Map 20 Rank",
    "Map 21 Rank", "Map 22 Rank", "Map 23 Rank", "Map 24 Rank", "Map 25 Rank"
};

[Setting hidden]
bool ShowWindow = true;

void RenderMenu() {
    if (UI::MenuItem(WindowTitle, "", ShowWindow)) {
        ShowWindow = !ShowWindow;
    }
}

void RenderInterface() {
    if (!ShowWindow) return;
    
    UI::SetNextWindowSize(600, 800, UI::Cond::FirstUseEver);

    if (UI::Begin(WindowTitle, ShowWindow, UI::WindowFlags::NoCollapse | UI::WindowFlags::NoResize)) {
        
        UI::SetWindowSize(vec2(600, 800)); 

        for (int i = 0; i < inputRanks.Length; i++) {
            inputRanks[i] = UI::InputInt(mapTexts[i], inputRanks[i]);
        }

        UI::Text(resultText);
        if (UI::Button("Calculate")) {
            int resultSum = 0;
            bool validInput = true;

            for (int i = 0; i < inputRanks.Length; i++) {
                if (inputRanks[i] < 1) {
                    validInput = false;
                    break;
                }
                resultSum += CalculateResult(inputRanks[i]);
            }

            if (!validInput) {
                resultText = "Improper number inputted - try again";
            } else {
                resultText = "Result: " + resultSum;
            }
        }

    }
    
    UI::End();
}

int CalculateResult(int rank) {
    if (rank < 11) {
        return 40000 / rank;
    } else {
        return int((4000 / Math::Pow(2, Math::Ceil(Math::Log(rank) / Math::Log(10)) - 1)) * (Math::Pow(10, Math::Ceil(Math::Log(rank) / Math::Log(10)) - 1) / rank + 0.9));
    }
}
*/

void Main() {
    print("Hello there!");
}

const string WindowTitle = "Campaign Points Calculator";
string resultText = "Result: ";
array<int> inputRanks(25, 1);
array<string> mapTexts = {
    "Map 1 Rank", "Map 2 Rank", "Map 3 Rank", "Map 4 Rank", "Map 5 Rank", 
    "Map 6 Rank", "Map 7 Rank", "Map 8 Rank", "Map 9 Rank", "Map 10 Rank", 
    "Map 11 Rank", "Map 12 Rank", "Map 13 Rank", "Map 14 Rank", "Map 15 Rank", 
    "Map 16 Rank", "Map 17 Rank", "Map 18 Rank", "Map 19 Rank", "Map 20 Rank",
    "Map 21 Rank", "Map 22 Rank", "Map 23 Rank", "Map 24 Rank", "Map 25 Rank"
};
array<int> mapPoints(25, 0);

[Setting hidden]
bool ShowWindow = true;

void RenderMenu() {
    if (UI::MenuItem(WindowTitle, "", ShowWindow)) {
        ShowWindow = !ShowWindow;
    }
}

void RenderInterface() {
    if (!ShowWindow) return;

    if (UI::Begin(WindowTitle, ShowWindow, UI::WindowFlags::NoCollapse | UI::WindowFlags::NoResize)) {
        
        UI::SetWindowSize(vec2(600, 850)); 

        for (int i = 0; i < inputRanks.Length; i++) {
            inputRanks[i] = UI::InputInt(mapTexts[i], inputRanks[i]);
        }

        UI::Text(resultText);
        if (UI::Button("Calculate")) {
            int resultSum = 0;
            bool validInput = true;

            for (int i = 0; i < inputRanks.Length; i++) {
                if (inputRanks[i] < 1) {
                    validInput = false;
                    break;
                }
                mapPoints[i] = CalculateResult(inputRanks[i]);
                resultSum += mapPoints[i];
            }

            if (!validInput) {
                resultText = "Improper number inputted - try again";
            } else {
                resultText = "Result: " + resultSum;
                UpdateMapTexts();
            }
        }

    }
    
    UI::End();
}

void UpdateMapTexts() {
    for (int i = 0; i < mapTexts.Length; i++) {
        mapTexts[i] = "Map " + (i+1) + " Rank (" + mapPoints[i] + " points)";
    }
}

int CalculateResult(int rank) {
    if (rank < 11) {
        return 40000 / rank;
    } else {
        return int((4000 / Math::Pow(2, Math::Ceil(Math::Log(rank) / Math::Log(10)) - 1)) * (Math::Pow(10, Math::Ceil(Math::Log(rank) / Math::Log(10)) - 1) / rank + 0.9));
    }
}



